# fluxtest-java

# I use Spring Boot  WebFlux + open-telemetry java agent, and add Baggage to the Context, but I found some problems.

1. When I call a normal block http api, everything is fine.
2. But when I call a flux http api, each traceId is duplicated for many times.
3. If I don't add baggage to Context and don't makeCurrent(), then everything is also fine.

# Reproduce steps:

## start the spring boot application:

1. ./start.sh

## test block http api:

1. ./curl.block.sh
2. every traceId only occurs one time:
   grep "afterRequest: message" ./log/fluxtest.log | grep -o "traceId: .*" | sort | uniq -c
   1 traceId: 0c77a443fdf6805255dc45d7e4b081ee
   1 traceId: 1c664755162528e1db26d6d092b33ce5
   1 traceId: 1dd168a2fb82d2d0e14c81212c83d64c
   1 traceId: 2a50b72268788b9dea36fdfdd7e00011
   1 traceId: 2ec776289c615dbe67fdab04362e9e14
   1 traceId: 3f6733d659a92ade5d983c87a4785577
   1 traceId: 48d7444c9e555ed53856d62ab9c6e9dd
   1 traceId: 599076924c6bc60ff5300fd160e72229
   1 traceId: 7312e7be092bd73792c43df669f2821f

## test flux stream api:

1. ./curl.stream.sh
2. traceId occurs multiple times:
   grep "afterRequest: message" ./log/fluxtest.log | grep -o "traceId: .*" | sort | uniq -c
   3 traceId: 3652f03eff152c912cc3122f6ec45cdb
   3 traceId: 3a5634c9822cc3df5b55c82311100d77
   6 traceId: 3e170528d0ade3a220c99de67472ad22
   3 traceId: 4ce87002d9952718c1469a5afe1f1e94
   3 traceId: aa924a592ea64b885a22f066557110ee
   3 traceId: e8f425a5c70dd07d07053c6454cb7e18

# some similar issues reported by others:

1. https://github.com/open-telemetry/opentelemetry-java-instrumentation/discussions/3168
2. https://github.com/open-telemetry/opentelemetry-java/issues/1531
