package com.fluxtest.controller;

import io.opentelemetry.api.trace.Span;
import io.opentelemetry.api.trace.SpanContext;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class CommonUtil {
    public static final String BAGGAGE_USER_ID = "gauge_at_user_id";
    public static final String SCOPE = "scope";

    public static String getTraceId(boolean setToLog) {
        Span currentSpan = Span.current();
        SpanContext spanContext = currentSpan.getSpanContext();
        String traceId = spanContext.isValid() ? spanContext.getTraceId() : "empty";
        /*
        if (setToLog) {
            MDC.put("traceId", traceId);
        }*/
        //return String.format("traceId=%s span.hash=%d spanCtx.hash=%d ", traceId, currentSpan.hashCode(), spanContext.hashCode());
        return traceId;
    }

    public static void print(String tag, boolean setLoggerTraceId) {
        log.info("telemetry: tag: {} traceId: {}", tag, getTraceId(setLoggerTraceId));
    }
}
