package com.fluxtest.controller;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.codec.ServerSentEvent;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Flux;

@RestController
@Slf4j
@RequestMapping("test/")
public class TestController {
    @Autowired
    TestService testService;

    @GetMapping("/stream")
    public Flux<ServerSentEvent<String>> streamEvents(String reqId) {
        return testService.getStreamResult(reqId);
    }

    @GetMapping("/block")
    public String blockEvents(String reqId) {
        return testService.getBlockResult(reqId);
    }

}


